package jogo;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

public class ClienteThread extends Thread {

    private ClientePrincipal pai;
    private ObjectOutputStream saida;
    private ObjectInputStream entrada;
    private String nome;
    private Mensagens msg;
    private int MarcaCarta;
    private String IPSERVIDOR;

    ClienteThread(String IP, ClientePrincipal aThis, String n) {
        this.IPSERVIDOR = IP;
        this.pai = aThis;
        this.nome = n;
    }

    /*public void enviarMensagem(String msg) {
    try {
    saida.writeObject(msg);
    } catch (IOException ex) {
    System.err.println("Erro ao enviar msg: " + ex.toString());
    }
    }*/
    @Override
    public void run() {
        Socket conexao;

        //String IPSERVIDOR = "127.0.0.1";


        try {
            conexao = new Socket(IPSERVIDOR, 1234);
            //obtendo os fluxos de entrada e de saida
            saida = new ObjectOutputStream(conexao.getOutputStream());
            entrada = new ObjectInputStream(conexao.getInputStream());

            boolean conectado = true;
            saida.writeObject(this.nome);
            int Rodada = 0;
            while (conectado) {

                msg = (Mensagens) entrada.readObject();
                //System.out.println(msg.getCodigo() + ":" + msg.getConteudo());
                int cod = msg.getCodigo();
                String corpo = msg.getConteudo();

                switch (cod) {
                    case 1:
                        pai.adicionarLinha(corpo);
                        
                        break;
                    case 2:
                        //pai.bloqueiaVira();
                        pai.NomeAdversario(corpo);
                        break;
                    case 10:
                        //Envia 4 Cartas String Jogador
                        System.out.println("Cartas " + nome + " " + corpo);
                        pai.criaBaralhoJogador(corpo);
                        saida.writeObject(new Mensagens(11, nome + "Recebeu Cartas..."));
                        break;
                    case 12:
                        System.out.println("Cartas" + nome + " " + corpo);
                        pai.criaBaralhoJogador(corpo);
                        saida.writeObject(new Mensagens(13, nome + "Recebeu Cartas..."));
                        break;
                    case 14:
                        //As cartas foram distribuidas e é a vez do Jogador escolher a carta...
                        this.setMarcaCarta(1);
                        pai.SuaVez(1);
                        break;
                    case 16:
                        //Outro Jogador já escolheu carta e será mostrado na tela...
                        //O jogador terá a vez...
                        String CartaVerso1[] = corpo.split(":");
                        System.out.println("A carta do outro Jogador eh " + CartaVerso1[0]);
                        pai.criaCartaAdversario(corpo);
                        this.setMarcaCarta(2);
                        pai.SuaVez(1);
                        break;
                    case 18:
                        //Outro Jogador já escolheu carta e será mostrado na tela...
                        //O jogador terá a vez...
                        String CartaVerso2[] = corpo.split(":");
                        System.out.println("A carta do outro Jogador eh " + CartaVerso2[0]);
                        pai.criaCartaAdversario(corpo);
                        saida.writeObject(new Mensagens(19, corpo));
                        break;

                    case 20:
                        //Você ganhou a rodada...

                        Thread.sleep(2000);
                        pai.LimpaCartas(0);
                        this.setMarcaCarta(1);
                        pai.adicionarLinha(corpo);
                        pai.SuaVez(1);

                        break;

                    case 22:
                        //Você perdeu e escreva isso no placar...
                        //e aguarda que o vencedor irá jogar pŕoxima carta
                        pai.adicionarLinha(corpo);
                        Thread.sleep(2000);
                        pai.LimpaCartas(0);
                        pai.SuaVez(0);
                        break;

                    case 24:
                        Thread.sleep(2000);
                        this.setMarcaCarta(1);
                        pai.LimpaCartas(0);
                        pai.adicionarLinha(corpo);
                        pai.SuaVez(1);
                        //empate
                        break;

                    case 26:
                        //empate
                        Thread.sleep(2000);
                        pai.LimpaCartas(0);
                        pai.adicionarLinha(corpo);
                        pai.SuaVez(0);
                        break;

                    case 28:
                        //vitoria
                        //marca ponto na partida

                        System.out.println("Vitoria: " + corpo);
                        pai.setTruco(1);
                        pai.SuaVez(0);
                        pai.MarcaPlacar(0,corpo);
                        pai.adicionarLinha("Vocẽ ganhou a partida.");
                        Thread.sleep(2000);
                        pai.LimpaMsg();
                        pai.LimpaCartas(1);
                        //int a = Integer.parseInt(pontos[0]);
                        //int b = Integer.parseInt(pontos[1]);
                        saida.writeObject(new Mensagens(27, corpo));
                        break;

                    case 30:
                        //derrota na partida
                        System.out.println("Derrota: " + corpo);
                        pai.setTruco(1);
                        pai.SuaVez(0);
                        pai.MarcaPlacar(0,corpo);
                        pai.adicionarLinha("Vocẽ perdeu a partida.");
                        Thread.sleep(2000);
                        pai.LimpaMsg();
                        pai.LimpaCartas(1);

                        break;

                    case 32:

                        //jogador foi trucado...
                        pai.adicionarLinha("Vocẽ está sendo trucado em " + corpo + " pontos .");

                        pai.Trucado(corpo);

                        break;

                    case 34:
                        //truco Aceito
                        pai.adicionarLinha(corpo);
                        break;

                    case 36:
                        //você está com mão de onze
                        break;


                    case 38:
                        //adversário está com mão de onze...
                        break;

                    case 40:
                        //os dois estão com mão de onze...

                        break;


                    case 42:
                        pai.MarcaPlacar(1, corpo);
                        pai.LimpaCartas(1);
                        pai.adicionarLinha("Vocẽ ganhou um set.");
                        saida.writeObject(new Mensagens(27, corpo));
                        //ganhador da partida
                        break;

                    case 44:
                        pai.MarcaPlacar(1, corpo);
                        pai.LimpaCartas(1);
                        pai.adicionarLinha("Vocẽ perdeu um set.");
                        //perdedor da partida


                        break;

                    case 50:
                        pai.adicionarLinha(corpo);
                        pai.SuaVez(1);
                        break;

                    default:
                        pai.adicionarLinha(corpo);
                        break;
                }


                /*
                if (cod==101) {
                String recebeCartas = (String) entrada.readObject();
                pai.criaBaralhoJogador(recebeCartas);
                }
                if (cod==102) {
                String recebeCartas = (String) entrada.readObject();
                pai.criaBaralhoJogador(recebeCartas);
                }

                if (corpo.equals("FIM")) {
                conectado = false;
                }*/

            }

            // fechando os fluxos e a conexao
            saida.close();
            entrada.close();
            conexao.close();
        } catch (Exception ex) {
            System.err.println("Erro sockets: " + ex.toString());
        }





    }

    public void enviaCartaServidor(String corpo) {
        try {
            if (this.getMarcaCarta() == 1) {

                this.saida.writeObject(new Mensagens(15, corpo));
            }
            if (this.getMarcaCarta() == 2) {
                this.saida.writeObject(new Mensagens(17, corpo));
            }

        } catch (IOException ex) {
            System.err.println("Erro ao enviar msg: " + ex.toString());
        }

    }

    public void PedeTruco() {
        try {
            //jogador pede truco...
            this.saida.writeObject(new Mensagens(21, "3"));
        } catch (IOException ex) {
            System.err.println("Erro ao enviar msg: " + ex.toString());
        }

    }

    public void AceitarTruco() {
        try {
            this.saida.writeObject(new Mensagens(23, "Aceito!"));
        } catch (IOException ex) {
            System.err.println("Erro ao enviar msg: " + ex.toString());
        }

    }

    public void AumentarTruco() {
        try {
            this.saida.writeObject(new Mensagens(25, "Aumento!"));
        } catch (IOException ex) {
            System.err.println("Erro ao enviar msg: " + ex.toString());
        }

    }

    public void Fugir(){
         try {
            this.saida.writeObject(new Mensagens(27, "Fugir..."));
        } catch (IOException ex) {
            System.err.println("Erro ao enviar msg: " + ex.toString());
        }

    
    }

    public void enviarMensagem(String corpo) {
        try {
            this.saida.writeObject(new Mensagens(1, corpo));
        } catch (IOException ex) {
            System.err.println("Erro ao enviar msg: " + ex.toString());
        }
    }

    public int getMarcaCarta() {
        return MarcaCarta;
    }

    public void setMarcaCarta(int MarcaCarta) {
        this.MarcaCarta = MarcaCarta;
    }
}
