package jogo;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;

public class ServidorThread extends Thread {

    private Socket conexao;
    private Servidor pai;
    private ArrayList<ObjectOutputStream> Jogadores;
    private ArrayList<String> baralho;
    private Mensagens msg;
    private Random sementeAleatoria;
    private String CartasMao;
    private String CartasPe;
    private int Jogador;

    public String getCartasA() {
        CartasMao = baralho.get(0) + ":" + baralho.get(1) + ":" + baralho.get(2) + ":" + baralho.get(3);
        return CartasMao;
    }

    public String getCartasB() {
        CartasPe = baralho.get(4) + ":" + baralho.get(5) + ":" + baralho.get(6) + ":" + baralho.get(3);
        return CartasPe;
    }

    public ServidorThread(Socket c, ArrayList<ObjectOutputStream> saidaDosClientes, ArrayList<String> b, Servidor p) {
        this.conexao = c;
        this.Jogadores = saidaDosClientes;
        this.baralho = b;
        this.sementeAleatoria = new Random();
        this.pai = p;

    }

   

    @Override
    public void run() {
        ObjectOutputStream saida;
        ObjectInputStream entrada;

        try {
            //obtendo os fluxos de entrada e de saida
            saida = new ObjectOutputStream(conexao.getOutputStream());
            entrada = new ObjectInputStream(conexao.getInputStream());
            // adicionando o fluxo de saida deste cliente no ArrayList compartilhado
            // por todas as threads
            this.Jogadores.add(saida);

            boolean conectado = true;



            String nomeCliente = (String) entrada.readObject();
            System.out.println(nomeCliente);
            saida.writeObject(new Mensagens(1, "Bem vindo ao Jogo de Truco!"));

            if (Jogadores.size() == 1) {
                pai.setNome1(nomeCliente);
                Jogadores.get(0).writeObject(new Mensagens(1, "Você é o Jogador1"));
                System.out.println("Jogador1 conectou...");

            }
            if (Jogadores.size() == 2) {
                pai.setNome2(nomeCliente);
                Jogadores.get(1).writeObject(new Mensagens(1, "Você é o Jogador2"));
                Jogadores.get(0).writeObject(new Mensagens(2, pai.getNome2()));
                Jogadores.get(1).writeObject(new Mensagens(2, pai.getNome1()));
                System.out.println("Jogador2 conectou...");
                System.out.println(baralho.size());
                Jogadores.get(0).writeObject(new Mensagens(10, this.getCartasA()));
                //Jogadores.get(1).writeObject(new Mensagens(10, this.getCartasPe()));
                //Jogadores.get(0).writeObject(new Mensagens(11, "Escolha uma carta..."));
            }

            while (conectado) {
                msg = (Mensagens) entrada.readObject();
                int cod = msg.getCodigo();
                String corpo = msg.getConteudo();
                this.Jogador = Jogadores.indexOf(saida);
                System.out.println("Jogador eh " + Jogadores.indexOf(saida));


                switch (cod) {

                    case 1:
                        // percorrendo todos os fluxos de saida dos clientes conectados
                        for (ObjectOutputStream outroJogador : Jogadores) {
                            if (saida != outroJogador) {
                                outroJogador.writeObject(new Mensagens(1, nomeCliente + "> " + corpo));
                            }
                        }
                        break;
                    case 11:
                        // JOgador COnfirma que recebeu as 3 cartas...
                        //Será enviadas as  do próximo...


                        System.out.println(corpo);
                        for (ObjectOutputStream outroJogador : Jogadores) {
                            if (saida != outroJogador) {
                                outroJogador.writeObject(new Mensagens(12, this.getCartasB()));
                            }
                        }
                        break;
                    case 13:
                        //Segundo Jogador Recebeu Carta e diz ser a vez do Outro joagador...
                        System.out.println(corpo);
                        for (ObjectOutputStream outroJogador : Jogadores) {
                            if (saida != outroJogador) {
                                outroJogador.writeObject(new Mensagens(14, "Sua vez..."));
                            }
                        }
                        break;

                    case 15:

                        //Primeira carta clicada...
                        //envia carta para cliente para ele desenhar na tela
                        //System.out.println("A primeira carta clicaca foi " + corpo);
                        //apenas armazenar ela no servdior

                        //precisa saber se é no escuro...

                        this.pai.setCarta1(corpo);
                        for (ObjectOutputStream outroJogador : Jogadores) {
                            if (saida != outroJogador) {
                                outroJogador.writeObject(new Mensagens(16, corpo));
                            }
                        }
                        break;
                    case 17:
                        //Segunda carta clicada, mas não está na mesa do OutroJogador
                        //precisa saber se é no escuro
                        //System.out.println(pai.getCarta1() + corpo);

                        for (ObjectOutputStream outroJogador : Jogadores) {
                            if (saida != outroJogador) {
                                outroJogador.writeObject(new Mensagens(18, corpo));
                            }
                        }
                        break;
                    case 19:
                        //Compara cartas e decidi ganhador

                        String CartaVerso1[] = pai.getCarta1().split(":");
                        String CartaVerso2[] = corpo.split(":");



                        System.out.println("Rodada eh: " + pai.getContaRodada());
                        System.out.println("Primeira Carta:" + CartaVerso1[0]);//outroJogador
                        System.out.println("Segunda Carta: " + CartaVerso2[0]);

                        int Pontos1 = 0;
                        int Pontos2 = 0;
                        //Colocar lógica de maiores cartas
                        //...

                        int PesoC1 = 0;
                        int PesoC2 = 0;
                        int PesoC1e = 0;
                        int PesoC2e = 0;
                        String vira = baralho.get(3);
                        String curinga = null;
                        //int curinga = 0;
                        String Carta1 = CartaVerso1[0];
                        String Carta2 = CartaVerso2[0];
                        String naipe = "aaaaaaaaaaaoecp";
                        String sequencia = "a4567djq123";
                        String cCompara = null;
                        //descobre número do curinga
                        for (int n = 0; n < sequencia.length(); n++) {
                            for (int f = 0; f < naipe.length(); f++) {
                                cCompara = "" + sequencia.charAt(n) + naipe.charAt(f);
                                if (cCompara.equals(vira)) {
                                    if (sequencia.charAt(n) == '3') {
                                        curinga = "" + sequencia.charAt(1) + naipe.charAt(f);
                                    } else {
                                        curinga = "" + sequencia.charAt(n + 1) + naipe.charAt(f);
                                    }
                                }
                            }
                        }
                        System.out.println("Este eh o vira " + vira);
                        System.out.println("este eh o curinga " + curinga.charAt(0));

                        //faz os pesos das cartas do jogadores
                        for (int n = 0; n < sequencia.length(); n++) {
                            for (int f = 0; f < naipe.length(); f++) {
                                cCompara = "" + sequencia.charAt(n) + naipe.charAt(f);
                                if (cCompara.equals(Carta1)) {
                                    if (CartaVerso1[1].equals("1")) {
                                        PesoC1 = 0;
                                        PesoC1e = 0;
                                    } else {
                                        if (Carta1.charAt(0) == curinga.charAt(0)) {
                                            PesoC1 = 100 + f;
                                            PesoC2e = 100 +f;
                                        } else {
                                            PesoC1 = n;
                                            PesoC1e = n + f;
                                        }
                                    }
                                }
                                if (cCompara.equals(Carta2)) {
                                    if (CartaVerso2[1].equals("1")) {
                                        PesoC2 = 0;
                                        PesoC2e = 0;
                                    } else {
                                        if (Carta2.charAt(0) == curinga.charAt(0)) {
                                            PesoC2 = 100 + f;
                                            PesoC2e= 100 + f;
                                        } else {
                                            PesoC2 = n;
                                            PesoC2e = n + f;
                                        }
                                    }
                                }
                            }
                        }
                        System.out.println(PesoC1);
                        System.out.println(PesoC2);
                        System.out.println(PesoC1e);
                        System.out.println(PesoC2e);

                        //decidi ganhador e perdedor





                        if (pai.getContaRodada() == 1) {
                            if (PesoC1 < PesoC2) {
                                for (ObjectOutputStream outroJogador : Jogadores) {
                                    if (saida != outroJogador) {
                                        outroJogador.writeObject(new Mensagens(20, "Vocẽ ganhou a primeira rodada..."));
                                    } else {
                                        if (Jogador == 0) {
                                            pai.jPlacar11();
                                        } else {
                                            pai.jPlacar01();
                                        }
                                        saida.writeObject(new Mensagens(22, "Você perdeu a primeira rodada..."));

                                    }
                                }
                            }

                            if (PesoC2 < PesoC1) {
                                for (ObjectOutputStream outroJogador : Jogadores) {
                                    if (saida != outroJogador) {
                                        outroJogador.writeObject(new Mensagens(22, "Vocẽ perdeu a primeira rodada..."));
                                    } else {
                                        if (Jogador == 0) {
                                            pai.jPlacar01();
                                        } else {
                                            pai.jPlacar11();
                                        }
                                        saida.writeObject(new Mensagens(20, "Você ganhou a primeira rodada..."));

                                    }
                                }
                            }

                            if (PesoC2 == PesoC1) {
                                for (ObjectOutputStream outroJogador : Jogadores) {
                                    if (saida != outroJogador) {
                                        outroJogador.writeObject(new Mensagens(24, "Empatou..."));
                                    } else {
                                        pai.jPlacar01();
                                        pai.jPlacar11();
                                        saida.writeObject(new Mensagens(26, "Empatou..."));
                                    }

                                }
                            }
                            pai.ContaRodada();
                            System.out.println("O placar da rodada está: " + pai.getjPlacar01() + ":" + pai.getjPlacar11());
                            break;

                        }

                        if (pai.getContaRodada() == 2) {

                            if (PesoC1 < PesoC2) {
                                for (ObjectOutputStream outroJogador : Jogadores) {
                                    if (saida != outroJogador) {
                                        outroJogador.writeObject(new Mensagens(20, "Vocẽ ganhou a segunda rodada..."));
                                    } else {
                                        if (Jogador == 0) {
                                            pai.jPlacar11();
                                        } else {
                                            pai.jPlacar01();
                                        }
                                        saida.writeObject(new Mensagens(22, "Você perdeu a segunda rodada..."));

                                    }
                                }
                            }

                            if (PesoC2 < PesoC1) {
                                for (ObjectOutputStream outroJogador : Jogadores) {
                                    if (saida != outroJogador) {
                                        outroJogador.writeObject(new Mensagens(22, "Vocẽ perdeu a segunda rodada..."));
                                    } else {
                                        if (Jogador == 0) {
                                            pai.jPlacar01();
                                        } else {
                                            pai.jPlacar11();
                                        }
                                        saida.writeObject(new Mensagens(20, "Vocẽ ganhou a segunda rodada..."));
                                    }
                                }
                            }

                            if (PesoC2 == PesoC1) {
                                pai.jPlacar01();
                                pai.jPlacar11();

                                if ((pai.getjPlacar01() == 2) && (pai.getjPlacar11() == 2)) {
                                    for (ObjectOutputStream outroJogador : Jogadores) {
                                        if (saida != outroJogador) {
                                            outroJogador.writeObject(new Mensagens(24, "Duas rodadas empatadas"));
                                        } else {
                                            saida.writeObject(new Mensagens(26, "Duas rodadas empatadas"));
                                        }

                                    }
                                    pai.ContaRodada();
                                    break;
                                } else {

                                    for (ObjectOutputStream outroJogador : Jogadores) {
                                        if (saida != outroJogador) {
                                            outroJogador.writeObject(new Mensagens(24, "Empatou..."));
                                        } else {
                                            pai.jPlacar01();
                                            pai.jPlacar11();

                                            saida.writeObject(new Mensagens(26, "Empatou..."));
                                        }
                                    }
                                }
                            }



                            if (pai.getjPlacar01() == 2) {

                                pai.setContaRodada(1);
                                Pontos1 = pai.getjPlacar02() + pai.getValorTruco();
                                System.out.println("Pontos1 " + Pontos1);
                                Pontos2 = pai.getjPlacar12();
                                System.out.println("Pontos2 " + Pontos2);
                                pai.setjPlacar02(Pontos1);
                                pai.setjPlacar12(Pontos2);
                                pai.setjPlacar01(0);
                                pai.setjPlacar11(0);
                                Jogadores.get(1).writeObject(new Mensagens(30, Pontos2 + ":" + Pontos1));
                                Jogadores.get(0).writeObject(new Mensagens(28, Pontos1 + ":" + Pontos2));
                                pai.setValorTruco(1);
                                break;
                            }
                            if (pai.getjPlacar11() == 2) {
                                pai.setContaRodada(1);
                                Pontos1 = pai.getjPlacar02();
                                System.out.println("Pontos1 " + Pontos1);
                                Pontos2 = pai.getjPlacar12() + pai.getValorTruco();
                                System.out.println("Pontos2 " + Pontos2);
                                pai.setjPlacar02(Pontos1);
                                pai.setjPlacar12(Pontos2);
                                pai.setjPlacar01(0);
                                pai.setjPlacar11(0);
                                Jogadores.get(1).writeObject(new Mensagens(28, Pontos2 + ":" + Pontos1));
                                Jogadores.get(0).writeObject(new Mensagens(30, Pontos1 + ":" + Pontos2));
                                pai.setValorTruco(1);
                                break;
                            }
                            pai.ContaRodada();
                            System.out.println("O placar da rodada está: " + pai.getjPlacar01() + ":" + pai.getjPlacar11());
                            break;
                        }


                        if (pai.getContaRodada() == 3) {
                            if (PesoC1e < PesoC2e) {
                                if (Jogador == 0) {
                                    pai.jPlacar11();
                                    pai.jPlacar11();
                                } else {
                                    pai.jPlacar01();
                                    pai.jPlacar01();
                                }
                            }

                            if (PesoC2e < PesoC1e) {
                                if (Jogador == 0) {
                                    pai.jPlacar01();
                                    pai.jPlacar01();
                                } else {
                                    pai.jPlacar11();
                                    pai.jPlacar11();
                                }
                            }
                            System.out.println("O placar da rodada está: " + pai.getjPlacar01() + ":" + pai.getjPlacar11());
                            System.out.println("teste soma " + 2 + 3 + 4 + "será ");

                            if (pai.getjPlacar01() > pai.getjPlacar11()) {
                                Pontos1 = pai.getjPlacar02() + pai.getValorTruco();
                                System.out.println("Pontos1 " + Pontos1);
                                Pontos2 = pai.getjPlacar12();
                                System.out.println("Pontos2 " + Pontos2);
                                pai.setjPlacar02(Pontos1);
                                pai.setjPlacar12(Pontos2);
                                pai.setjPlacar01(0);
                                pai.setjPlacar11(0);

                                Jogadores.get(1).writeObject(new Mensagens(30, Pontos2 + ":" + Pontos1));
                                Jogadores.get(0).writeObject(new Mensagens(28, Pontos1 + ":" + Pontos2));
                                pai.setValorTruco(1);
                            }
                            if (pai.getjPlacar01() < pai.getjPlacar11()) {
                                Pontos1 = pai.getjPlacar02();
                                System.out.println("Pontos1 " + Pontos1);
                                Pontos2 = pai.getjPlacar12() + pai.getValorTruco();
                                System.out.println("Pontos2 " + Pontos2);
                                pai.setjPlacar02(Pontos1);
                                pai.setjPlacar12(Pontos2);
                                pai.setjPlacar01(0);
                                pai.setjPlacar11(0);

                                Jogadores.get(1).writeObject(new Mensagens(28, Pontos2 + ":" + Pontos1));
                                Jogadores.get(0).writeObject(new Mensagens(30, Pontos1 + ":" + Pontos2));
                                pai.setValorTruco(1);
                            }
                            pai.setContaRodada(1);
                        }
                        break;


                    case 21:

                        //truca jogador...
                        //
                        if (pai.getTrucador() == 5) {
                            pai.setTrucador(Jogador);
                        }

                        if (pai.getValorTruco() == 1) {
                            for (ObjectOutputStream outroJogador : Jogadores) {
                                if (saida != outroJogador) {
                                    outroJogador.writeObject(new Mensagens(32, "3"));
                                }
                            }
                            pai.setValorTruco(3);
                            System.out.println("1 Valor do truco: " + pai.getValorTruco());
                            break;
                        }

                        if (pai.getValorTruco() == 3) {
                            for (ObjectOutputStream outroJogador : Jogadores) {
                                if (saida != outroJogador) {
                                    outroJogador.writeObject(new Mensagens(32, "6"));
                                }
                            }
                            pai.setValorTruco(6);
                            System.out.println("2 Valor do truco: " + pai.getValorTruco());
                            break;
                        }

                        if (pai.getValorTruco() == 6) {

                            for (ObjectOutputStream outroJogador : Jogadores) {
                                if (saida != outroJogador) {
                                    outroJogador.writeObject(new Mensagens(32, "9"));

                                }

                            }
                            pai.setValorTruco(9);
                            System.out.println("4 Valor do truco: " + pai.getValorTruco());
                            break;

                        }

                        if (pai.getValorTruco() == 9) {

                            for (ObjectOutputStream outroJogador : Jogadores) {
                                if (saida != outroJogador) {
                                    outroJogador.writeObject(new Mensagens(32, "12"));

                                }

                            }
                            pai.setValorTruco(12);
                            System.out.println("3 Valor do truco: " + pai.getValorTruco());
                            break;

                        }

                        break;

                    case 23:
                        //Aceitou truco...

                        if (pai.getValorTruco() == 1) {
                            pai.setValorTruco(3);
                        }
                        if (pai.getTrucador() == 0) {
                            Jogadores.get(0).writeObject(new Mensagens(50, "Jogo Trucado. Você começa!"));
                            Jogadores.get(1).writeObject(new Mensagens(34, "Jogo Trucado. Aguarde o adversário."));
                        } else {
                            Jogadores.get(1).writeObject(new Mensagens(50, "Jogo Trucado. Você começa!"));
                            Jogadores.get(0).writeObject(new Mensagens(34, "Jogo Trucado. Aguarde o adversário."));
                        }
                        pai.setTrucador(5);
                        break;

                    case 25:

                        break;

                    case 27:

                        System.out.println("Nova Partida!!!");

                        if (corpo.equals("Fugir...")) {
                            int FugiuTruco = 0;
                            if (pai.getValorTruco() == 3){
                                FugiuTruco = 1;
                            } else{
                                FugiuTruco = pai.getValorTruco() -3 ;
                            }
                            

                            if (Jogador == 0) {
                                Pontos1 = pai.getjPlacar02();
                                Pontos2 = pai.getjPlacar12()+FugiuTruco;
                                Jogadores.get(0).writeObject(new Mensagens(30, Pontos1 + ":" + Pontos2));
                                Jogadores.get(1).writeObject(new Mensagens(28, Pontos2 + ":" + Pontos1));

                            } else {

                                Pontos1 = pai.getjPlacar02()+FugiuTruco;
                                Pontos2 = pai.getjPlacar12();
                                Jogadores.get(0).writeObject(new Mensagens(28, Pontos1 + ":" + Pontos2));
                                Jogadores.get(1).writeObject(new Mensagens(30, Pontos2 + ":" + Pontos1));
                            }

                            //Pontos1 = pai.getjPlacar02();
                            System.out.println("Pontos1 " + Pontos1);
                            //Pontos2 = pai.getjPlacar12();
                            System.out.println("Pontos2 " + Pontos2);
                            pai.setjPlacar02(Pontos1);
                            pai.setjPlacar12(Pontos2);
                            pai.setjPlacar01(0);
                            pai.setjPlacar11(0);
                            break;
                        }

                        pai.setValorTruco(1);
/*
                        if (pai.getjPlacar02() == 11 && pai.getjPlacar12() == 11) {
                            Jogadores.get(0).writeObject(new Mensagens(40, "Escurinho."));
                            Jogadores.get(1).writeObject(new Mensagens(40, "Escurinho"));
                            break;
                        }
                        if (pai.getjPlacar02() == 11) {
                            Jogadores.get(0).writeObject(new Mensagens(36, "Você está com mão de Onze.Deseja Jogar Valendo 3 Pontos?"));
                            Jogadores.get(1).writeObject(new Mensagens(38, "Adversário está com mão de Onze e está decidindo se vai Jogadr."));
                            break;
                            //jogador 1 com mão de onze
                        }
                        if (pai.getjPlacar12() == 11) {
                            Jogadores.get(1).writeObject(new Mensagens(36, "Você está com mão de Onze."));
                            Jogadores.get(0).writeObject(new Mensagens(38, "Adversário está com mão de Onze."));

                            break;

                            //jogador 2 com mão de onze
                        }
*/
                       if (pai.getjPlacar02() >= 12) {
                            pai.jPlacar03();
                            int i =0;
                            if (pai.getjPlacar03() == 2) {
                                i =2;
                                pai.setjPlacar03(0);
                                pai.setjPlacar13(0);
                            }
                            Jogadores.get(0).writeObject(new Mensagens(42, pai.getjPlacar03() + ":" + pai.getjPlacar13()));
                            Jogadores.get(1).writeObject(new Mensagens(44, pai.getjPlacar13() + ":" + pai.getjPlacar03()));
                            pai.setjPlacar02(0);
                            pai.setjPlacar12(0);

                            if (i == 2) {
                                Jogadores.get(0).writeObject(new Mensagens(1, "Vocẽ ganhou o jogo de TRUCO. PARABÉNS!!!"));
                                Jogadores.get(1).writeObject(new Mensagens(1, "Vocẽ perdeu o jogo de TRUCO."));
                                Jogadores.get(1).writeObject(new Mensagens(1, "Aguarde sua vez."));

                            }
                            break;
                        }
                        if (pai.getjPlacar12() >= 12) {
                            //jogador 2 ganhou
                            pai.jPlacar13();
                            int i =0;
                            if (pai.getjPlacar13() == 2) {
                                i =2;
                                pai.setjPlacar03(0);
                                pai.setjPlacar13(0);

                            }
                            Jogadores.get(1).writeObject(new Mensagens(42, pai.getjPlacar13() + ":" + pai.getjPlacar03()));
                            Jogadores.get(0).writeObject(new Mensagens(44, pai.getjPlacar03() + ":" + pai.getjPlacar13()));
                            pai.setjPlacar02(0);
                            pai.setjPlacar12(0);

                            if (i == 2) {
                                Jogadores.get(1).writeObject(new Mensagens(1, "Vocẽ ganhou o jogo de TRUCO. PARABÉNS!!!"));
                                Jogadores.get(0).writeObject(new Mensagens(1, "Vocẽ perdeu o jogo de TRUCO."));
                                Jogadores.get(0).writeObject(new Mensagens(1, "Aguarde sua vez."));

                            }
                            break;
                        }

                        this.pai.embaralhar();

                        if (Jogador == 0) {
                            Jogadores.get(0).writeObject(new Mensagens(10, this.getCartasA()));
                        } else {
                            Jogadores.get(1).writeObject(new Mensagens(10, this.getCartasA()));
                        }




                        break;

                    case 29:
                        //Jogador irá jogar na mão de onze
                        pai.setValorTruco(3);
                        if (Jogador == 0) {
                            Jogadores.get(0).writeObject(new Mensagens(10, this.getCartasA()));
                        } else {
                            Jogadores.get(1).writeObject(new Mensagens(10, this.getCartasA()));
                        }
                        break;



                    default:
                        System.out.println(nomeCliente + "> " + corpo);
                        break;

                    /* if (corpo.equals("FIM")) {
                    conectado = false;
                    saida.writeObject("FIM");
                    // removendo o fluxo de saida do ArrayList
                    outrosClientes.remove(saida);
                    
                    } /*else {
                    // percorrendo todos os fluxos de saida dos clientes conectados
                    for (ObjectOutputStream outraSaida : outrosClientes) {
                    if (saida != outraSaida) {
                    outraSaida.writeObject(nomeCliente + "> " + corpo);
                    }
                    }*/
                }
            }

            // fechando os fluxos e a conexao
            saida.close();
            entrada.close();
            conexao.close();
        } catch (Exception ex) {
            System.err.println("Erro sockets: " + ex.toString());
        }

    }
}
